<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import { logisticServiceOfferInjectionKey } from '@/logisticServiceOffer/constants'
    import { LogisticServiceOffer } from '@/logisticServiceOffer/entities/logisticServiceOffer/LogisticServiceOffer'
    import { LogisticServiceOfferApi } from '@/logisticServiceOffer/entities/logisticServiceOffer/LogisticServiceOfferApi'
    import { logisticServiceOfferMapper } from '@/logisticServiceOffer/entities/logisticServiceOffer/LogisticServiceOfferMapper'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import RouteNavigationDrawer from '@/serviceOffer/components/administration/SRouteNavigationDrawer.vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { isDefined } from '@/shared/helpers/types'
    import { computed, inject, ref, Ref } from 'vue'
    import { useRouter } from 'vue-router'

    const msal = useMsal()
    const router = useRouter()

    const logisticServiceOfferApi = new LogisticServiceOfferApi(msal)

    const logisticServiceOffer = inject(logisticServiceOfferInjectionKey) as
        | Ref<LogisticServiceOffer>
        | undefined

    const formIsValid = ref<boolean>(false)

    const rules = {
        hasType: (input: string | undefined) =>
            !!input || "Vous devez sélectionner un type d'inventaire",
    }

    const typeDInventaires = computed(
        () => logisticServiceOffer?.value.gmaoConfiguration.typeDInventaires
    )

    async function updateLogisticServiceOffer() {
        if (logisticServiceOffer?.value) {
            try {
                const logisticServiceOfferDto =
                    logisticServiceOfferMapper.toEditDto(
                        logisticServiceOffer.value
                    )
                await logisticServiceOfferApi.update(
                    logisticServiceOffer.value.id,
                    logisticServiceOfferDto
                )

                emitSnackBar(
                    `Type d'inventaire modifié en ${logisticServiceOffer.value?.gmaoConfiguration.typeDInventaires
                        .find(
                            (typeDInventaire) =>
                                typeDInventaire.id ===
                                logisticServiceOffer.value?.typeDInventaireId
                        )
                        ?.libele.toLocaleLowerCase()}`,
                    'primary'
                )
                router.push({
                    name: 'logistic-service-offer/index',
                })
            } catch (error) {
                emitSnackBar((<Error>error).message, 'error')
                router.push({
                    name: 'logistic-service-offer/index',
                })
            }
        }
    }
</script>

<template>
    <route-navigation-drawer
        v-if="isDefined(logisticServiceOffer)"
        page-title="Type d'inventaire"
        :service-offer-id="logisticServiceOffer.id"
        :service-offer-type="logisticServiceOffer.template"
        :page-is-loading="!logisticServiceOffer"
    >
    </route-navigation-drawer>
    <v-main>
        <s-content-container>
            <v-form
                v-if="logisticServiceOffer"
                v-model="formIsValid"
                @submit.prevent="updateLogisticServiceOffer"
            >
                <v-select
                    v-model="logisticServiceOffer.typeDInventaireId"
                    label="Type d'inventaire"
                    variant="outlined"
                    class="mb-3"
                    :items="typeDInventaires"
                    item-title="libele"
                    item-value="id"
                    data-cy="select-inventory-type"
                    :rules="[rules.hasType]"
                ></v-select>
                <p class="text-right">
                    <s-action-button
                        icon="mdi-check"
                        label="Enregistrer"
                        type="submit"
                        :disabled="!formIsValid"
                        :loading="logisticServiceOfferApi.isProcessing.value"
                        data-cy="submit-inventory-type"
                    >
                    </s-action-button>
                </p>
            </v-form>
        </s-content-container>
    </v-main>
</template>
